!****************************************************************************************
!*** u(Tree)vւ̃f[^̒ǋL  ꊇo                                   ***
!***                               gpf[^\Fu2T (Binary Search Tree)v ***
!***                          gpASYFu}(insert)vuf(traversal)v ***
!****************************************************************************************
!
! prjFEMɂuאڍs(adjacency matrix)viS̎RxԂ̐ڑ֌Wj̑g
!       i אڍs̊es2T؂ŕ\                                     j
!       i āCsŜ͑2T؂琬uX(forest)vŕ\ j
!
! juf[^\ƃASYv̊błuXg(list)vCuċA(recursion)vC
!     ɂ́uX^bN(stack)v̒mƂ悢D
!
!          X^bNFs|ɉ炩̖ڈLĂipushjC
!                    A|ɂ̋LoipopjƂł悤ɂ邽߂̋L
!
!
!*****************************************************
! 2T(Binary Search Tree)
!
! f[^\̈łC̊{P(u_(vertex, node)v)͍\^ƃ|C^ŎD
!
!   jJԂ̃f[^ǋLi폜jɑ΂āC**̃f[^ɐԂƂłD
!       ifȔzł͖̍Đɔʂ̃f[^ړKvC̓t̂݁j
!       ̓f[^TɗLłCO(n)̐`TłȂO(log(n))2TƂłD
!
!   Zj\^ƃ|C^̍lɂ邽߁C₷z\ɔׁCGD
!
!  Eu2؁vƂ́Cォ牺Ɂu(e)v獶E2ꂽu}(q)vL΂ẮD
!     i䂦ɖ{IɍċAł̋LqCN{Ij
!  Eu2T؁vƂ́C2؂̈łC̎}(q)ɍ(e)菬ȒlC
!      E̎}(q)ɍ(e)傫ȒlĂۂ́D
!    i̐ɂC̃f[^ɐԂƂłāCf[^TNɂȂj
!
!   )                b                             b
!                      50                             25
!                   ^    _                             _
!                 35        60                              35
!               ^  _    ^  _                               _
!             25     40  55     61                                40  
!                         _                                         _
!                          58                                           50
!            ioXǂꍇj        ioXň̏ꍇFAXgƓ)
!
!   ⑫j
!       Eu؁v́CĤȂLOtƂ
!       E钸_ȉ̕ɒڂƂCɁu؁vƂ
!
! ȂC{Pʁi_j̃f[^\ƁC̈ʓIȕ\͉LC
!
!    TYPE, PRIVATE :: vtx                                   !        _______ 
!       INTEGER :: c                      ! f[^̂  !       |___c___|
!       TYPE(vtx), POINTER :: L => NULL() ! ̎qw    !       |_L_|_R_|
!       TYPE(vtx), POINTER :: R => NULL() ! E   V         !       ^     _
!    END TYPE vtx                                           !      v         v
!
! ċAASY̗eՉ邽߂ɁC{Pʂ̃f[^\ƃASŶ悤ɗZ
! \LĂDiċA͂点Ki~Ă悤ȃC[WDǂň̂hj
!
!    RECURSIVE SUBROUTINE kernel ( ptr )
!       TYPE(vtx), POINTER, INTENT(inout) :: ptr  ! |C^ԂւINTENTw F2003
!       IF ( .NOT. ASSOCIATED(ptr) ) RETURN
!       ! a)  ptr%c ΁Cs(O)      !      ptr  v            
!       CALL kernel ( ptr%L )                               !    a   ___|___   c
!       ! b)  ptr%c ΁Cʂ肪()      !       |_ptr%c_|
!       CALL kernel ( ptr%R )                               ! ptr%L ^     _ ptr%R  
!       ! c)  ptr%c ΁CA肪(㏇)      !      v    b    v
!    END SUBROUTINE kernel
!
! ̂ƂC2؂̍ċA͍}̂悤ɕ\łD              root |
!                                              __0th_FL__               v               _____
!                                                                       v
!                                                                  a ___|___ c
!                                                                   |___50__|
!                                                                   ^  b  _
!                                              __1st_FL__          v         v          _____
!                                                                  v         v
!                                                           a ___^__ c      _ NULL()
!                                                            |___35__|
!                                                            ^  b  _
!                                              __2nd_FL__   v         v                 _____
!                                                           v         v
!                                                  NULL() ^           _ NULL()
!
!*****************************************************
! f[^ǋL̂߂ 2T؂ւ́u}(insert)v ASY
!
!    ܂͊Yf[^XgAς݂ł邩ۂċAIɏɒׂif[^TjD
!    Ȃ킿CYf[^gƈvΒǋLɏI邪C菬΍̎qցC
!    傫ΉE̎q֌JԂׂĂi3jD͂߂Ė[܂ŒׂƁC
!    XgAς݂łȂVKf[^ł邱Ƃm肷̂ŁCŌɒׂ̂VɐeƂāC
!    ̎qƂăXgAD̍ہCe菬΍̎qC傫ΉE̎qƂȂD
!
!    ⑫j̗Ⴉ悤ɁCf[^̃XgAɂ؂̌`ςD
!          EɃoX悭XgAłƁCl̑}ETƂ O(log(n)) ŏłD
!          Cς݂̃f[^𒀎ǋLƁCEǂ炩ɂ̂ݐLт̂ŁC
!          ň O(n) ̐`TƂȂ̂ŗvӁD
!
!    ֑joXۂԂ2T؂ĂASYiFԍ؁CAVL؁j
!          邪CFEMprł͂قڕsvD
!          RFFEMł́CoXȂ؂͏ȂC؂̒_ieRx
!          ڑ鎩Rx̐Cאڍs1s̔[jςŐ10瑽Ƃ100D
!          ܂C؂̖{iRxj͐炩琔SȂ̂ŁCoX؂̌vZRXg
!          ͖łD
!
!
!*****************************************************
! Sf[^ꊇô߂ 2T؂́uf(traversal)vASY
!
!   uf(traveral)vƂ́C̎菇Ŗ؂̑SẮu_vK邱ƂD
!    Ȃ킿C؂̍̍炮Ɩ؂𒭂߂Ă܂C؂̍̉EɎD̂ƂC
!    e_̗̈ a,b,c ƖtĂƁCe_ɂ a,b,c ̏ɕK3񗧂
!    ƂɂȂD؂ɒ߂ꏄƂCe_̗̈ a ʉ߂Ƃɂ
!    炩̏菇̂ƂCus(O)vCb uʂ肪()vC
!    c A肪(㏇) ƂD̎菇͎Ɏ悤ɖ{IɍċAłD
!
!      a) s(OFpre-order traversal)
!           (1)_f[^̕\                                             b
!           (2)̕؂K₷ċAďo                             a 50 c
!           (3)E̕؂K₷ċAďo                            ^  b _
!           \f[^F50,35,25,40,36,42,60,61                    a 35 c    a 60 c
!                                                                    ^ b_     ' b_
!      b) ʂ肪(Fin-order traversal)                   a 25 c  a 40 c    a 61 c
!           (1)̕؂K₷ċAďo                     ' b`   ^ b_     ' b`
!           (2)_f[^̕\                                      a 36 c  a 42 c
!           (3)E̕؂K₷ċAďo                         ' b`    ' b`
!           \f[^F25,35,40,42,50,60,61i, ascendj
!                                                                           
!      c) A肪(㏇Fpost-order traversal)
!           (1)̕؂K₷ċAďo
!           (2)E̕؂K₷ċAďo
!           (3)_f[^̕\
!           \f[^F25,36,42,40,35,61,60,50
!
!
!*****************************************************
! ⑫jċA(recursive)vO̒ӓ_ƁC̔ċA
!
!  ċAvO͊Ȍł邪Ĉ悤Ȗ肪邽߁CėpCułׂ͔
!    EċA[ȂƁCX^bNI[o[t[̉\
!    E֐Ăяoɂ̓I[o[wbh邽߁C炩x
!
!  ʂɍċA͔ċAł邱ƂDċA͕KċAłD
!    iCċARpCŔċAĂ邩ǂ͕ʖj
!
! ċAvOł́CRpCɗŃX^bN쐬Cpush  pop ĂD
! CċAꍇɂ͎ŃX^bNz쐬i傫߂Ȃ΂ȂȂjC
! push  popȂ΂ȂȂD
!
!
!*****************************************************
! ⑫jOpen-MP }`Xbhł ALLOCATE / DEALLOCATE (malloc/free) ɂ͗v
!
!  cygwin ł multi-threading ł malloc ̐\IɈ܂܁D
!    https://www.cygwin.com/ml/cygwin/2013-02/msg00308.html
!    "Re: wrong performance of malloc/free under multi-threading"
!    (Linux gcc ł͖Ȃlqj
!    ȂȂ΁CSXbhŋʂ̃q[vgƂCbNĂ邽߁D
!
!  IntelRpC ł́Cmulti-threading  malloc ɖ͂ȂD
!    http://www.isus.jp/article/intelguide/3-1/
!    ȂȂ΁CXbhɃ[Jȃq[vĂ邽߁D
!    ŁCmalloc ƕʃXbhfreeƁC\ȂD
!    "User and Reference Guide for the IntelR Fortran Compiler 15.0"
!    "IntelR Compiler Extension Routines to OpenMP*" Ɉȉ̋LqD
!    "  The IntelR Fortran Compiler implements a group of memory allocation routines 
!     as an extension to the OpenMP* run-time library to enable threads to allocate 
!     memory from a heap local to each thread. These routines are: KMP_MALLOC(), 
!     KMP_CALLOC(), and KMP_REALLOC(). 
!       The memory allocated by these routines must also be freed by the KMP_FREE() routine.
!     While you can allocate memory in one thread and then free that memory in a different
!     thread, this mode of operation incurs a slight performance penalty. 
!
!
MODULE BS_tree_class

   IMPLICIT none
   PRIVATE

   TYPE, PRIVATE :: vtx                   ! 2؂̊{\vfF_ (vertex, node)
      INTEGER :: c                        !       ___|___ 
      TYPE(vtx), POINTER :: L => NULL()   !      |___c___|      c: Cell data, Contents
      TYPE(vtx), POINTER :: R => NULL()   !      |_L_|_R_|      L: Left
   END TYPE vtx                           !      ^     _      R: Right
                                          !     v         v

   TYPE, PUBLIC :: tree_c                 ! ۃf[^ƂĂ2T
      PRIVATE
      TYPE(vtx), POINTER :: root => NULL()! ؂̍
      INTEGER :: nvtx = 0                 ! _=f[^̌î߂Ɂj
   END TYPE tree_c

   PUBLIC :: insert
   INTERFACE insert
    ! MODULE PROCEDURE insert_datum_R     ! wKp̍ċA(Recursive)
      MODULE PROCEDURE insert_datum_NR    ! ċA(Non-Recursive)
      MODULE PROCEDURE insert_data_NR     ! ꊇo^
   END INTERFACE

   PUBLIC :: get_ndat
   INTERFACE get_ndat
       MODULE PROCEDURE get_ndat
   END INTERFACE

   PUBLIC :: get_dat
   INTERFACE get_dat
    ! MODULE PROCEDURE traversal_asend_R
      MODULE PROCEDURE traversal_asend_NR
   END INTERFACE

   PUBLIC :: display
   INTERFACE display
      MODULE PROCEDURE display_R
   END INTERFACE

   PUBLIC :: final
   INTERFACE final
    ! MODULE PROCEDURE dealloc_R
      MODULE PROCEDURE dealloc_NR
   END INTERFACE

   PUBLIC :: renumber
   INTERFACE renumber
!     MODULE PROCEDURE renumber_R
     MODULE PROCEDURE renumber_NR
   END INTERFACE

   TYPE, PRIVATE :: vtx_ptr               ! FortranŃ|C^z\邽߂̃gbN
      TYPE(vtx), POINTER :: ptr           ! iċAɖIɕKvƂȂX^bN̂߂Ɂj
   END TYPE vtx_ptr                       ! {̓_u|C^iFortranKOjƗǂ

CONTAINS
!
!********************************************************************************************
   SUBROUTINE insert_datum_R ( this, a )  ! datum ̕` data

      ! 2T؂ɒPf[^ a ǋLiwKp̍ċAŁj

      TYPE(tree_c), INTENT(inout) :: this
      INTEGER,      INTENT(in   ) :: a

      CALL insert_kernel( this%root )

   CONTAINS

      RECURSIVE SUBROUTINE insert_kernel( ptr )
         TYPE(vtx), POINTER, INTENT(inout) :: ptr ! |C^ԂւINTENTw F2003
         IF ( ASSOCIATED(ptr) ) THEN       ! 炩̃f[^o^ĂꍇC
            IF      ( a == ptr%c ) THEN    !    a ɓo^ς݂ȂΒT
               RETURN                      !                        iċA𔲂j
            ELSE IF ( a <  ptr%c ) THEN    !    Ȃ΁C܂͍̎qTɂ
               CALL insert_kernel( ptr%L )
            ELSE                           !                ɉE̎qTɂ
               CALL insert_kernel( ptr%R )
            END IF
         ELSE                              ! ɂǂ蒅̂́Co^ȊOɂȂ
            ALLOCATE(ptr)                  ! Ȃ̂œo^
            ptr%c = a
            this%nvtx = this%nvtx +1
            RETURN
         END IF
      END SUBROUTINE insert_kernel

   END SUBROUTINE insert_datum_R


   SUBROUTINE insert_datum_NR ( this , a )

      ! 2T؂ɒPf[^ a ǋLiċAŁj

      TYPE(tree_c), INTENT(inout) :: this
      INTEGER,      INTENT(in   ) :: a

      TYPE(vtx), POINTER :: ptr

      ! L BS_loop {̂ɂǂ蒅OɁCOKv
      IF ( .NOT. ASSOCIATED(this%root) ) THEN  ! Ȃ΍Ȃ̂ŁC
         ALLOCATE(this%root)
         this%root%c = a
         this%nvtx   = 1
         RETURN
      END IF

      ptr => this%root
      BS_loop: DO      ! 2T(Binary Search)ĂC̃f[^Ȃꍇ̂ݒǋL

         IF      ( a == ptr%c ) THEN      ! a ɓo^ς݂ȂΒT
            EXIT BS_loop
         ELSE IF ( a <  ptr%c ) THEN      ! Ȃ΁C܂̎qTɂ
            IF ( ASSOCIATED(ptr%L) ) THEN !    q΁C
               ptr   => ptr%L
            ELSE                          !    Ȃ΁Ca ͖o^
               ALLOCATE(ptr%L)            !       Ȃ̂œo^
               ptr   => ptr%L
               ptr%c =  a
               this%nvtx = this%nvtx +1
               EXIT BS_loop
            END IF
         ELSE  ! ( a >  ptr%c )           ! ɂǂ蒅̂́CE̎q̏ꍇ̂
            IF ( ASSOCIATED(ptr%R) ) THEN !   ȉ͒̏ꍇƓ
               ptr   => ptr%R
            ELSE
               ALLOCATE(ptr%R)            !   jFortranɂ̓_u|C^Ȃ̂
               ptr   => ptr%R             !       L, R𕪂𓾂Ȃ
               ptr%c =  a
               this%nvtx = this%nvtx +1
               EXIT BS_loop
            END IF
         END IF

       ! ! jL͖ȂɌ邪CԈႢ
       !       iɂFortranKiɂȂ_u|C^K{j
       ! IF      (a==ptr%c) THEN
       !    EXIT BS_loop
       ! ELSE IF (a< ptr%c) THEN
       !    ptr = ptr%L              ! ȃ_u|C^Fortranł͖iLqKiᔽj
       ! ELSE  ! (a> ptr%c)
       !    ptr = ptr%R
       ! END IF
       ! IF ( .NOT. ASSOCIATED(ptr) ) THEN
       !    ALLOCATE(ptr)            ! ptrwɑ΂alloc ̂łȂC
       !    ptr%c =  a               ! ptr̂ɑ΂alloc ̂ŁCptr̎w悪ς
       !    this%nvtx = this%nvtx +1
       !    EXIT BS_loop
       ! END IF

      END DO BS_loop

   END SUBROUTINE insert_datum_NR


   SUBROUTINE insert_data_NR ( this , buf )

      ! 2T؂Ƀf[^ dat(:) ǋLiPf[^̒ǋĽJԂj

      TYPE(tree_c), INTENT(inout) :: this
      INTEGER,      INTENT(in   ) :: buf(:)  ! f[^i[p̃obt@

      INTEGER            :: n       ! f[^
      TYPE(vtx), POINTER :: ptr
      INTEGER            :: a
      INTEGER            :: i, st, j, sgn

      n = SIZE(buf)

      ! dat(:)ς݃f[^Ȃ \ 肪 \ CO12T؂
      ! ǋLĂƐ`XgɂȂD͍ňp^[łD
      ! ŁC邽߁CL For_each_dat_loop ł͊ȈՃVbt{
      ! ȈՃVbt̕jF͂߂čȄ݂
      ! ) dat(1:10) Ȃ΁C5Ԗ ͂߂ 6,4, 7,3, 8,2, 9,1, 10
      ! ) dat(1:11) Ȃ΁C6Ԗ ͂߂ 7,5, 8,4, 9,3,10,2, 11,1

      ! L For_each_dat_loop ̂߂̏lݒ
      j   = (n+1)/2                   ! dat(j)  j ͒͂߂
      st  = 1                         ! [vJE^ i ̊Jnl
      sgn = 1                         ! ꂩ̂߂̕⏕ϐ

      ! L For_each_dat_loop {̂ɂǂ蒅OɁCOKv
      IF ( .NOT. ASSOCIATED(this%root) ) THEN ! Ȃ΍Ȃ̂ŁC
         ALLOCATE(this%root)
         this%root%c = buf(j)
         this%nvtx   = 1
         ! ̗OɂƂȂCFor_each_dat_loop ̏Ŏ{𓾂Ȃ
         sgn = -sgn
         j   = j + sgn*(st-1)         ! j=j Ȃ̂C₷̂߂Ɂc
         st  = st +1                  ! {ς݂䂦C[vJE^ i ̊JnlJ
      END IF

      For_each_dat_loop: DO i = st, n

         sgn = -sgn                   ! tɂ
         j   = j + sgn*(i-1)          ! ̏ɂ j ͒͂߂čEݏƂȂ
         a   = buf(j)

         ! ȉ insert_datum_NR Ɠ
         ptr => this%root
         BS_loop: DO
            IF      ( a == ptr%c ) THEN
               EXIT BS_loop
            ELSE IF ( a <  ptr%c ) THEN
               IF ( ASSOCIATED(ptr%L) ) THEN
                  ptr   => ptr%L
               ELSE
                  ALLOCATE(ptr%L)
                  ptr   => ptr%L
                  ptr%c =  a
                  this%nvtx = this%nvtx +1
                  EXIT BS_loop
               END IF
            ELSE  ! ( a >  ptr%c )
               IF ( ASSOCIATED(ptr%R) ) THEN
                  ptr   => ptr%R
               ELSE
                  ALLOCATE(ptr%R)
                  ptr   => ptr%R
                  ptr%c =  a
                  this%nvtx = this%nvtx +1
                  EXIT BS_loop
               END IF
            END IF
         END DO BS_loop

      END DO For_each_dat_loop

   END SUBROUTINE insert_data_NR

!
!********************************************************************************************
   FUNCTION get_ndat ( this ) RESULT( ans )
       ! 2T؂̒_(f[^)Ԃ
       TYPE(tree_c), INTENT(in   ) :: this
       INTEGER                     :: ans
       ans = this%nvtx
   END FUNCTION get_ndat


!********************************************************************************************
   SUBROUTINE traversal_asend_R ( this, buf, n_ )

      ! 2Tؒ̑Sf[^(asend)Ŕz buf ɎoiwKp̍ċAŁj

      TYPE(tree_c),      INTENT(in   ) :: this
      INTEGER,           INTENT(out  ) :: buf(:)  ! Sf[^op̔z  SIZE(buf) >= n_
      INTEGER, OPTIONAL, INTENT(out  ) :: n_      ! f[^

      INTEGER :: cnt   ! Kς݂̒_

      IF ( SIZE(buf) < this%nvtx ) STOP "BS_tree_class: Sf[^ô߂̃obt@s"
      IF ( PRESENT(n_) ) n_ = this%nvtx

      ! ʂ肪()ɂ鉡f (in-order traversal)
      cnt = 0
      CALL trvsl_inorder( this%root )

   CONTAINS

      RECURSIVE SUBROUTINE trvsl_inorder( ptr )
         TYPE(vtx), POINTER, INTENT(in   ) :: ptr ! |C^ԂւINTENTw F2003
         IF ( .NOT. ASSOCIATED(ptr) ) THEN
            RETURN
         ELSE
            CALL trvsl_inorder( ptr%L )
            cnt = cnt +1
            buf(cnt) = ptr%c
            CALL trvsl_inorder( ptr%R )
         END IF
      END SUBROUTINE trvsl_inorder

   END SUBROUTINE  traversal_asend_R


   SUBROUTINE traversal_asend_NR ( this, buf, n_ )

      ! 2Tؒ̑Sf[^(asend)Ŕz buf ɎoiċAŁj

      TYPE(tree_c),      INTENT(in   ) :: this
      INTEGER,           INTENT(out  ) :: buf(:)  ! Sf[^op̔z  SIZE(buf) >= n_
      INTEGER, OPTIONAL, INTENT(out  ) :: n_      ! f[^

      TYPE(vtx_ptr) :: stack(this%nvtx+1)         ! ziRpCWł̓X^bNɁj
      INTEGER       :: sp, cnt                    ! Stack Pointer & CouNTer

      IF ( SIZE(buf) < this%nvtx ) STOP "BS_tree_class: Sf[^ô߂̃obt@s"
      IF ( PRESENT(n_) ) n_ = this%nvtx

      IF ( .NOT. ASSOCIATED(this%root) ) RETURN
      ! ʂ肪()ɂ鉡f (in-order traversal)
      sp = 1                                      
      stack(sp)%ptr => this%root
      DO cnt = 1, this%nvtx
         DO WHILE( ASSOCIATED( stack(sp)%ptr  ) ) ! ɍs邾i݂C
            stack(sp+1)%ptr => stack(sp)%ptr%L    !  pushiX^bNɖ߂ɕKvȏςށj
            sp = sp +1
         END DO
         sp = sp -1                               ! 1 popiX^bN߂ɕKvȏoj
         buf(cnt)      =  stack(sp)%ptr%c
         stack(sp)%ptr => stack(sp)%ptr%R
      END DO
      ! Iɂ sp = 1

   END  SUBROUTINE traversal_asend_NR

!********************************************************************************************
   SUBROUTINE display_R ( this, width_ )

      ! ؂ʂɊȈՏói90x]ԂŁj

      TYPE(tree_c),      INTENT(in   ) :: this
      INTEGER, OPTIONAL, INTENT(in   ) :: width_   !  [1̈󎚒

      INTEGER       :: width
      CHARACTER(80) :: fmt

      IF ( PRESENT( width_ ) ) THEN
         width = width_
      ELSE
         width = 5         ! ftHgl
      END IF

      WRITE(*,*) ''
      WRITE(*,*) '؂90x]ԂŊȈՏo'
      CALL trvsl_in( this%root, 0 )         ! tił̒ʂ肪()
      WRITE(*,*) ''

   CONTAINS

      RECURSIVE SUBROUTINE trvsl_in( ptr, depth )
         ! tił̒ʂ肪()  iʏ L  R Cł͋t R  L j
         TYPE(vtx), POINTER, INTENT(in   ) :: ptr
         INTEGER,            INTENT(in   ) :: depth
         IF ( .NOT. ASSOCIATED(ptr) ) THEN
            RETURN
         ELSE
            CALL trvsl_in( ptr%R, depth+1 )   ! LeftłȂ Right CALL
            WRITE(fmt,"('(',I3,'x, I',I2,')')") 1+width*depth, width  ! t@C
            WRITE(*,fmt) ptr%c
            CALL trvsl_in( ptr%L, depth+1 )
         END IF
      END SUBROUTINE trvsl_in

   END SUBROUTINE  display_R

!
!********************************************************************************************
   SUBROUTINE dealloc_R ( this )
      ! iwKp̍ċAŁj
      TYPE(tree_c), INTENT(inout) :: this
      ! A肪(㏇)ɂ鉡f (post-order traversal)
      CALL trvsl_post( this%root )
      this%nvtx = 0
   CONTAINS
      RECURSIVE SUBROUTINE trvsl_post( ptr )
         TYPE(vtx), POINTER, INTENT(inout) :: ptr
         IF ( .NOT. ASSOCIATED(ptr) ) RETURN
         CALL trvsl_post( ptr%L )
         CALL trvsl_post( ptr%R )
         ! ɂǂ蒅ɂ́C͂A肪
         ! zIɂ́Cɐ旧̂悤ɃS~l߂Ăׂ
         ! ptr%c = ()
         ! ptr%L => NULL()         ! NULLIFY(ptr%L) Ɠ
         ! ptr%R => NULL()
         DEALLOCATE( ptr )         ! ptr w̃Cw null ƂȂ
      END SUBROUTINE trvsl_post
      ! jsȂǂł deallocate ł邪CA肪ł͕svł
      !     ϐ ptrL, ptrRi=X^bNɐς܂jKvƂȂiLjD
      !  RECURSIVE SUBROUTINE trvsl_pre ( ptr )
      !      :
      !     ptrL => ptr%L
      !     ptrR => prr%R
      !     DEALLOCATE( ptr )
      !     CALL trvsl_pre( ptrL )
      !     CALL trvsl_pre( ptrR )
   END SUBROUTINE  dealloc_R


   SUBROUTINE dealloc_NR ( this )

      ! iċAŁj

      TYPE(tree_c), INTENT(inout) :: this

      TYPE(vtx_ptr) :: stack(this%nvtx+1)         ! ziRpCWł̓X^bNɁj
      INTEGER       :: sp, cnt                    ! Stack Pointer & CouNTer

      IF ( .NOT. ASSOCIATED(this%root) ) RETURN
      ! A肪(㏇)ɂ鉡f(post-order traversal)
      sp = 1                                      ! A肪̏ꍇCS stack(:) ɋ킹
      stack(sp)%ptr => this%root                  ! ܂ĂłȂƁCfoȂD
      DO WHILE ( sp > 0 )
         IF      ( ASSOCIATED( stack(sp)%ptr%L) ) THEN
            stack(sp+1)%ptr => stack(sp)%ptr%L    ! push
            stack(sp)%ptr%L => NULL()             ! A肪𔻕ʂ邽߂ɕKvȃtO
            sp = sp +1
         ELSE IF ( ASSOCIATED( stack(sp)%ptr%R) ) THEN
            stack(sp+1)%ptr => stack(sp)%ptr%R    ! push
            stack(sp)%ptr%R => NULL()             ! A肪𔻕ʂ邽߂ɕKvȃtO
            sp = sp +1
         ELSE                                     ! A肪
            DEALLOCATE( stack(sp)%ptr )
            sp = sp -1                            ! pop
         END IF
      END DO

      this%nvtx = 0

   END SUBROUTINE  dealloc_NR

!
!********************************************************************************************
   SUBROUTINE renumber_R ( this, o2n )
      ! f[^̔ԍtւiwKp̍ċAŁj
      ! ` f[^orgԍVf[^newԍւ̕ϊe[u o2n(:) ɊÂ `
      TYPE(tree_c), INTENT(inout) :: this
      INTEGER,      INTENT(in   ) :: o2n(:)
      TYPE(vtx), POINTER :: org_root
      IF ( .NOT. ASSOCIATED(this%root) ) RETURN
      org_root  => this%root     !  org_root Ɍq
      this%root => NULL()        ! this%root ɐV؂΂点邽߂ɁD
      ! A肪(㏇)ɂ鉡f (post-order traversal)
      CALL trvsl_post( org_root )
   CONTAINS
      RECURSIVE SUBROUTINE trvsl_post( ptr )
         TYPE(vtx), POINTER, INTENT(inout) :: ptr ! |C^ԂւINTENTw F2003
         IF ( .NOT. ASSOCIATED(ptr) ) RETURN
         CALL trvsl_post( ptr%L )
         CALL trvsl_post( ptr%R )
         ! 悤₭܂œBɂ́C͂A蓹
         ptr%c = o2n(ptr%c)      ! ԍtւƂƂɁCthis%rootɒǋL邽߁C
         ptr%L => NULL()         ! E̎qւ̗}؂藎ƂĈxtɖ߂Ă
         ptr%R => NULL()         ! ȏCptr̐gӐICthis%rootȉւ̌q
         ! tւɂǋLiċA̒ɍċAj
         CALL insert_kernel( this%root, ptr )
      END SUBROUTINE trvsl_post
      RECURSIVE SUBROUTINE insert_kernel( ptr, p_vtx )
         TYPE(vtx), POINTER, INTENT(inout) :: ptr
         TYPE(vtx), POINTER, INTENT(inout) :: p_vtx
         IF ( ASSOCIATED(ptr) ) THEN
            IF      ( p_vtx%c == ptr%c ) THEN     ! ʂ͗L蓾ȂC
               this%nvtx = this%nvtx -1           ! o2n(:)  11 ̑ΉłȂꍇ̏
               DEALLOCATE( p_vtx )
               RETURN
            ELSE IF ( p_vtx%c <  ptr%c ) THEN
               CALL insert_kernel( ptr%L, p_vtx )
            ELSE
               CALL insert_kernel( ptr%R, p_vtx )
            END IF
         ELSE
            ptr => p_vtx
            RETURN
         END IF
      END SUBROUTINE insert_kernel
   END SUBROUTINE renumber_R


   SUBROUTINE renumber_NR ( this, o2n )

      ! f[^̔ԍtւ
      ! ` f[^oldԍVf[^newԍւ̕ϊe[u o2n(:) ɊÂ `

      TYPE(tree_c), INTENT(inout) :: this
      INTEGER,      INTENT(in   ) :: o2n(:)

      TYPE(tree_c), POINTER :: org_root

      TYPE(vtx_ptr)         :: stack(this%nvtx+1) ! ziWł̓X^bN̈ɐς܂j
      INTEGER               :: sp, cnt            ! Stack Pointer & CouNTer

      IF ( .NOT. ASSOCIATED(this%root) ) RETURN

      ! A肪(㏇)ɂ鉡f(post-order traversal)
      sp = 1
      stack(sp)%ptr => this%root
      this%root     => NULL()                     ! this%root ɐV؂΂点邽߂
      DO WHILE ( sp > 0 )
         IF      ( ASSOCIATED( stack(sp)%ptr%L) ) THEN
            stack(sp+1)%ptr => stack(sp)%ptr%L    ! push
            stack(sp)%ptr%L => NULL()             ! A肪𔻕ʂ邽߂ɕKvȃtO
            sp = sp +1
         ELSE IF ( ASSOCIATED( stack(sp)%ptr%R) ) THEN
            stack(sp+1)%ptr => stack(sp)%ptr%R    ! push
            stack(sp)%ptr%R => NULL()             ! A肪𔻕ʂ邽߂ɕKvȃtO
            sp = sp +1
         ELSE                                     ! A肪
            ! Yf[^stack(sp)%ptr%c ̔ԍtւāCthis%root ȉɒǋL
            stack(sp)%ptr%c = o2n( stack(sp)%ptr%c )
            CALL insert_vtx_NR( this%root, stack(sp)%ptr )
            sp = sp -1                            ! pop
         END IF
      END DO

   CONTAINS

      SUBROUTINE insert_vtx_NR ( root, p_vtx )

         TYPE(vtx), POINTER, INTENT(inout) :: root  ! V؂̍
         TYPE(vtx), POINTER, INTENT(inout) :: p_vtx ! ǋL_

         TYPE(vtx), POINTER :: ptr

         IF ( .NOT. ASSOCIATED( root ) ) THEN
            root => p_vtx
            RETURN
         END IF

         ptr => root
         BS_loop: DO
            IF      ( p_vtx%c == ptr%c ) THEN     ! ʂ͗L蓾ȂC
               this%nvtx = this%nvtx -1           ! o2n(:)  11 ̑ΉłȂꍇ̏
               DEALLOCATE( p_vtx )
               EXIT BS_loop
            ELSE IF ( p_vtx%c <  ptr%c ) THEN
               IF ( ASSOCIATED(ptr%L) ) THEN
                  ptr   => ptr%L
               ELSE
                  ptr%L => p_vtx
                  EXIT BS_loop
               END IF
            ELSE  ! ( p_vtx%c >  ptr%c )
               IF ( ASSOCIATED(ptr%R) ) THEN
                  ptr   => ptr%R
               ELSE
                  ptr%R => p_vtx
                  EXIT BS_loop
               END IF
            END IF
         END DO BS_loop

      END SUBROUTINE insert_vtx_NR

   END SUBROUTINE renumber_NR

END MODULE BS_tree_class