PROGRAM main_linear

   USE constants
   USE material_class  ! ޗNX
   USE element_class   ! vfNX
   USE adj_mtx_class   ! אڍsNX (ADJacent MaTriX)
   USE sp_mtx_class    ! asNX   (SPaRse   MaTriX)
   USE timer_class
   USE mesh_module     ! \XpQeB

   USE cond_node_class ! قƂǃXpQeB
   USE GiD_IO_module   ! \XpQeB
!$ USE OMP_LIB

   IMPLICIT none

   INTEGER                  :: nmat            ! Sޗ̈搔  (Num of MATerials)
   TYPE(mat_c), ALLOCATABLE :: mat_DB   ( : )  ! (nmat  )      ޗ̈̕lDataBase

   INTEGER                  :: nnode           ! S̐ߓ_    (Num of NODEs    )
   REAL(DP),    ALLOCATABLE :: X_DB     (:,:)  ! (ndim ,nnode) ߓ_WDataBase

   INTEGER                  :: nelm            ! vf        (Num of ELeMents )
   TYPE(elm_c), ALLOCATABLE :: elm_DB   ( : )  ! (nelm  )      vfɊւDataBase

   INTEGER                  :: ncndn           ! D/NEۂߓ_(Num of CoND. Nodes)
   TYPE(cndn_c)             :: cndn            ! ߓ_ɊւD/N]̏W

   INTEGER,     ALLOCATABLE :: elm2DOFg(:,:)   ! ڑs
   TYPE(jag),   ALLOCATABLE :: col2elm(:)      ! F̗vf
   INTEGER                  :: ic, p

   INTEGER,     ALLOCATABLE :: node2DOFg(:,:)  ! (nDOFn,nnode) S̐ߓ_ԍSDOFԍ
                                               !  nDOFn        ߓ_DOF
   INTEGER                  :: nDOF_n          ! D(1)̍ŏSDOFԍ < 0, Nega
   INTEGER                  :: nDOF_p          ! N(2)  ő   V       > 0, Posi, +
   REAL(DP),    ALLOCATABLE :: U  (:)          ! (nDOF_n:nDOF_p) m( :-1)/m(1: ) ψ
   REAL(DP),    ALLOCATABLE :: Fin(:)          ! (     V      ) ́ieGlM̌zj
   REAL(DP),    ALLOCATABLE :: Fex(:)          ! (     V      ) m( :-1)/m(1: ) O
   REAL(DP),    ALLOCATABLE :: F  (:)          ! (     1:nDOF_p) c

   TYPE(adj_mtx_c)          :: A_pp            ! SDOFɊւאڍs
   TYPE(sp_mtx_c)           :: K_pp            ! S̐ڐsieGlM̃wbZsj

   INTEGER                  :: DOFe2g  (nDOFe) ! vfDOFԍSDOFԍւ̕ϊDB
   REAL(DP)                 :: Ue      (nDOFe) ! vfψʐxNg
   REAL(DP)                 :: Fine    (nDOFe) ! vf͐xNg
   REAL(DP)                 :: Ke(nDOFe,nDOFe) ! vfڐs
   REAL(DP) :: dF2ex2
   INTEGER  :: step, i, k

   CHARACTER(MAXCHAR) :: ID        ! fi̓t@CQ̋ʖj

   INTEGER  :: nThreads = 0        ! OMP_NUM_THREADS iOpen-MP񉻂Ȃꍇ 0 j
   REAL(DP) :: wtime(10)

!$ nThreads = OMP_GET_MAX_THREADS()
   IF ( nThreads == 0 ) THEN
      WRITE(*,'("s")')
   ELSE
      WRITE(*,'("Open-MPs ( OMP_NUM_THREADS = ",I2," )")') nThreads
   END IF

!   ID = "example1"
   WRITE(*,'(A)',advance='no') 'fi̓t@CQ̋ʖjF'
   READ (*,'(A)') ID

   CALL read_files_and_set
!
   CALL tic()
   ! vf̃}`J[
   ALLOCATE( elm2DOFg(nDOFe,nelm) )
   DO k = 1, nelm
      elm2DOFg(:,k) = get_DOFg( elm_DB(k), node2DOFg )
   END DO
   CALL mk_col2elm_from_elm2DOFg( col2elm, elm2DOFg )
   DEALLOCATE( elm2DOFg )
   wtime(1) = toc()

   CALL tic()
   ! אڍs A_pp ̍쐬
   CALL init( A_pp, nDOF_p )
   !$OMP PARALLEL
   DO ic = LBOUND(col2elm,dim=1), UBOUND(col2elm,dim=1)
   !$OMP DO PRIVATE( p, k, DOFe2g )
      DO p = 1, SIZE(col2elm(ic)%c)
         k = col2elm(ic)%c(p)
         DOFe2g(:) = get_DOFg( elm_DB(k), node2DOFg )
         CALL add_clique( A_pp, DOFe2g )
      END DO
      !$OMP END DO
   END DO
   !$OMP END PARALLEL
!   CALL wrt( A_pp, 'A_pp_mtx_org.dat')! אڍso
   wtime(2) = toc()

   CALL tic()
!   ! ioO
   CALL renumber( A_pp, node2DOFg )
!   CALL wrt( A_pp, 'A_pp_mtx_new.dat')! אڍso
   wtime(3) = toc()

   ! ڐs K_pp Ɛߓ_ Fin ̍쐬
   CALL tic()
   CALL init( K_pp, A_pp )
   wtime(4) = toc()

   ALLOCATE ( U  (nDOF_n:nDOF_p), &
            & Fin(nDOF_n:nDOF_p), &
            & Fex(nDOF_n:nDOF_p), &
            & F  (1     :nDOF_p)  )

   !$OMP PARALLEL WORKSHARE
   U  (:) = 0.0_DP
   Fex(:) = 0.0_DP
   Fin(:) = 0.0_DP
   !$OMP END PARALLEL WORKSHARE
   dF2ex2 = 0.0_DP

   ! D/N E̐ݒiR[h̓XpQeBj
   CALL proceed_next_U_and_Fex( cndn, node2DOFg, nDOF_n, nDOF_p, U, Fex, dF2ex2 )

   CALL tic()
   !$OMP PARALLEL
   DO i = LBOUND(col2elm,DIM=1), UBOUND(col2elm,DIM=1)
      !$OMP DO PRIVATE( p, k, DOFe2g, Ue, Fine, Ke )
      DO p = 1, SIZE(col2elm(i)%c)
         k = col2elm(i)%c(p)
         DOFe2g(:) = get_DOFg( elm_DB(k), node2DOFg )
         Ue(:)     = U(DOFe2g(:))
         CALL eval_Fin_and_K( elm_DB(k), X_DB, mat_DB, Ue , Fine, Ke )
         Fin(DOFe2g(:)) = Fin(DOFe2g(:)) + Fine(:)
         CALL add_clique( K_pp, Ke, DOFe2g )
      END DO
      !$OMP END DO
   END DO
   !$OMP END PARALLEL
   wtime(5) = toc()

   ! 
   !$OMP PARALLEL WORKSHARE
   F(:) = Fex(1: ) - Fin(1: )
   !$OMP END PARALLEL WORKSHARE

   CALL tic()
   CALL solve( K_pp, F, U(1: ) )
   wtime(6) = toc()

   CALL final( K_pp )
   CALL final( A_pp )
   CALL final( cndn )

   ! |XgvZXiGiDp̏ój
   step = 1
   CALL init_GiD_postfile( ID,       X_DB, elm_DB )
   CALL  wrt_GiD_postfile( ID, step, X_DB, elm_DB, mat_DB,        &
                         & nDOF_n, nDOF_p, U, Fin, Fex, node2DOFg )

   WRITE(*,'("---- vZԂ̓ibj OMP_NUM_THREADS = ",I2,"----")'), nThreads
   WRITE(*,'("  }`J[: ",F10.3)') wtime(1)
   WRITE(*,'("  אڍs̍쐬: ",F10.3)') wtime(2)
   WRITE(*,'("  Rxԍt: ",F10.3)') wtime(3)
   WRITE(*,'("  _ELXg: ",F10.3)') wtime(4)
   WRITE(*,'("  s̍쐬: ",F10.3)') wtime(5)
   WRITE(*,'("  ̋:   ",F10.3)') wtime(6)
!
CONTAINS
!**********************************************************************
   SUBROUTINE read_files_and_set ( )

      INTEGER :: uid = 50  ! uԍ
      INTEGER :: i, dummy, nbelm
      LOGICAL :: exist

      ! ܂́CzɓIɃ蓖Ă邽߂ɕKvƂȂlǂݍ
      OPEN (uid,file=TRIM(ID)//'.size.dat', action='read')
      READ (uid,*) nnode
      READ (uid,*) nelm
      READ (uid,*) nmat
      READ (uid,*) nbelm
      READ (uid,*) dummy  ! dummy (ǂݍ݂ςȂ߂j
      READ (uid,*) ncndn  !  size.dat ɓ郁bgȂD*.cndt@CɓׂH
      CLOSE(uid)

      ! ߓ_Wl̓ǂݍ
      ALLOCATE( X_DB(ndim  ,nnode ) )
      OPEN( uid, file=TRIM(ID)//'.node.dat', action='read')
      DO i = 1, nnode
         READ (uid,*) X_DB(:,i)
      END DO
      CLOSE(uid)

      ! vff[^i\^j̓ǂݍ
      ALLOCATE( elm_DB( nelm ) )
      OPEN( uid, file=TRIM(ID)//'.elm.dat', action='read')
      DO i = 1, nelm
         CALL init( elm_DB(i), uid )
      END DO
      CLOSE(uid)

      ! ޗ̈f[^i\^j̓ǂݍ
      ALLOCATE( mat_DB( nmat ) )
      OPEN( uid, file=TRIM(ID)//'.mat.dat', action='read')
      DO i = 1, nmat
         CALL init( mat_DB(i), uid )
      END DO
      CLOSE(uid)

      ! ߓ_Ɋւ D/NEǂݍނƂƂɁCSDOFԍ()UD
      nDOF_n = 0
      nDOF_p = 0
      ALLOCATE( node2DOFg( nDOFn, nnode ) )
      OPEN( uid, file=TRIM(ID)//'.cndn.dat', action='read')
      CALL init( cndn, ncndn, uid, node2DOFg, nDOF_n, nDOF_p )
      CLOSE(uid)

   END SUBROUTINE read_files_and_set

END PROGRAM main_linear
