!*****************************************************************
!****     LvfbVɊւ͂s[`W        ****
!*****************************************************************
!
! (Voume, 3-D)C(Face, 2-D), (Edge, 1-D), ߓ_(Node, 0-D) ̊֌W͂D
! ʂ FEM ł́CV2N ݂̂^邱ƂC V2E  E2N ȂǑ̊֌WKv
! Ȃ邱ƂDŖ{W[́C̊֌WvZ郋[`W߂̂łD
!
! ȂCV2E(:,:)  E2N(:,:) CV -> F -> E -> N ̕ւ́C`ziϊj
! ŋLqł邪C̋tCȂ킿 E2V  N2E  jagged(MUMU)zitϊj
! ̍lKvƂȂD܂C͈ʑCt͈ʑ͎ȂD
! {R[hł́CV,F,E,N𒊏ۉ A,B,C ŕ\CA -> B -> C ̕ƂD
! A -> B -> C  V -> E -> N ł V -> F -> N ŗǂD

MODULE mesh_module

   USE constants, ONLY: jag
   USE buffer_class
   USE sort_and_search_module
   IMPLICIT none
   PRIVATE

   PUBLIC :: mk_col2elm_from_elm2DOFg
   PUBLIC :: mk_A2B_from_A2C_and_preB2C
   PUBLIC :: mk_B2C_from_A2B_A2C_and_preB2C
   PUBLIC :: mk_tree_of_B_in_C

CONTAINS
!
!*********************
   SUBROUTINE mk_col2elm_from_elm2DOFg ( col2elm, elm2DOFg )

      ! vfԍSDOFԍe[u elm2DOFg(1:nDOFe,1:nelm) ƂɁC
      ! 񏈗̂߂ɗLvfʐF (Multi-Coloring) 邱ƂŁC
      ! Fԍvfԍe[u col2elm(1:ncol)%c(:) ԂD

      ! iȂCvfԍFŕtւ΁Ccol2elm ŕϊԂȂj

      USE adj_mtx_class

      TYPE(jag), ALLOCATABLE, INTENT(out  ) :: col2elm(:)   ! (ALLOCATABLEF2003K)
      INTEGER,                INTENT(in   ) :: elm2DOFg(:,:)

      TYPE(jag), ALLOCATABLE :: DOFg2elm(:)         ! elm2DOFg̋t(vf=_CRx=)
      INTEGER,   ALLOCATABLE :: elm2col(:)
      TYPE(adj_mtx_c)        :: dual_A              ! tDOFg2elmɊÂOt̗אڍs
      INTEGER :: nelm
      INTEGER :: nDOF_n                             ! D̍ŏSDOFԍ < 0, Nega
      INTEGER :: nDOF_p                             ! N̍őSDOFԍ > 0, Posi, +
      INTEGER :: i

      ! elm2DOFg(:,:)̋tDOFg2elm(:)%c(:)쐬
      CALL mk_Y2X_from_X2Y_2D( DOFg2elm, elm2DOFg )

      nelm   = SIZE  (elm2DOFg, dim=2)
      nDOF_n = LBOUND(DOFg2elm, dim=1)
      nDOF_p = UBOUND(DOFg2elm, dim=1)

      ! tDOFg2elm(i)%c(:)Ɋւאڍs \ vf𒸓_ƂOt \ 쐬
      CALL init( dual_A, nelm )
      DO i = nDOF_n, nDOF_p
         CALL add_clique( dual_A, DOFg2elm(i)%c )
      END DO

!CALL wrt( rev_A, 'elm_adj.dat') ! SDOFvfɊւאڍso

      ! Ot_ƂĂ̗vfʐF
      ALLOCATE( elm2col(nelm) )
      CALL do_coloring( dual_A, elm2col )           ! vf𒸓_ƂOt̒_ʐF
      CALL final( dual_A )

!OPEN(77,file="elm_color.dat")
!WRITE(77,'(I5)') elm2col
!CLOSE(77)

      ! elm2col(:)tcol2elm(ic)%c(:)쐬
      CALL mk_Y2X_from_X2Y_1D( col2elm, elm2col )
      DEALLOCATE( elm2col )

   END SUBROUTINE mk_col2elm_from_elm2DOFg
!
!*********************
   SUBROUTINE mk_Y2X_from_X2Y_1D ( Y2X, X2Y, minY_, maxY_ )

      ! e[u X2Y(1:nX)  te[u Y2X(minY:maxY)%c(:) 쐬ic(:)͏j
      ! i1z񂾂CtjaggedzȂ̂ŒӁj

      TYPE(jag), ALLOCATABLE, INTENT(out  ) :: Y2X(:)  !(minY:maxY)  t (ALcF2003K)
      INTEGER,                INTENT(in   ) :: X2Y(:)  !(1:nX)       
      INTEGER,  OPTIONAL,     INTENT(in   ) :: minY_   ! MINVAL(X2Y)  maxY_ ƃZbg
      INTEGER,  OPTIONAL,     INTENT(in   ) :: maxY_   ! MAXVAL(X2Y)  minY_    V

      ! ⑫jFUNCTION Ƃ SUBROUTINE ƂR
      !                   ` ւALLOCATABLE(F2003K)Ɋւ钍ӓ_ `
      !
      !    => ALLOCATABLE̊tԂ߂ɂ́CFUNCTION ̖߂lł͖Ȃ̂ŁC
      !       ËƂ邩C߂lPOINTERƂKv邽߁D
      !
      !yẑ悤Ɋ֐Ő錾ĂقCꌩCg肪悳łc
      
      !         FUNCTION rev_tbl ( X2Y ) RESULT ( Y2X ) 
      !            TYPE(jag), ALLOCATABLE :: Y2X(:)
      !            ALLOCATE( Y2X(-2:5) )
      !                   :
      !         END FUNCTION rev_tbl
      !
      !   CĂяo玟̂悤Ȏg͂łȂD
      !
      !         TYPE(jag), ALLOCATABLE :: Y2X(:)
      !         Y2X = rev_tbl( X2Y )    ! G[i֐ł̊tԂ Y2X ɖ߂Ȃj
      !
      !   1) ̊֐gꍇC͎̒ʂD
      !
      !         TYPE(jag), ALLOCATABLE :: Y2X(:)
      !         ALLOCATE( Y2X(-5:8) )   ! ܂ti㉺Ȃꍇ͑傫߂Ɋmہj
      !         Y2X( UBOUND(rev_tbl(X2Y)):LBOUND(rev_tbl(X2Y)) ) = rev_tbl( X2Y )
      !
      !      ㉺Ă΁Ĉ悤ɊȌɂȂD
      !
      !         ALLOCATE( Y2X(-2:5) )   ! ܂t
      !         Y2X = rev_tbl( X2Y )
      !
      !      ̂悤ɁC㉺ꍇɂ FUNCTION gbg낤CȂ
      !      č̂Ɓi֐̖߂lALLOCATABLEĂCĂяo̍
      !      i摤jɂ͊tԂ͖߂ȂjDȂCFUNCTION ̖߂lւ ALLOCATABLE 
      !      ́CɎ̂悤ȏꍇz肵ĂƍlD
      !
      !         WRITE(*,*) rev_tbl( X2Y )       ! IɎIɉ
      !         b(:) = b(:) + rev_tbl( X2Y )    ! ]    V
      !                                         ! g݊֐ MATMUL Ɠ悤Ȏg
      !
      !   2) FUNCTION ̖߂lƂꍇĈ悤ALLOCATABLE  POINTER  (F90/95K)D
      !
      !         FUNCTION rev_tbl ( X2Y ) RESULT ( Y2X ) 
      !            TYPE(jag), POINTER :: Y2X(:) ! POINTER 
      !            ALLOCATE( Y2X(-2:5) )
      !                :
      !         END FUNCTION rev_tbl
      !
      !      ĂяoF
      !
      !         TYPE(jag), POINTER :: Y2X(:)
      !         Y2X => func( X2Y )              ! |C^̎QƂ = ł͂Ȃ =>
      !             :
      !         DEALLOCATE( Y2X )               ! DEALLOCATEK{DȂ΃[N

      !*********************************************
      ! ⑫jւALLOCATABLE(F2003K)t^ ́C𓾂ȂƂ݂̂Ɍ
      !
      !    ȂȂ΁C
      !       1j ALLOCATABLE tĂƁCɐÓIznȂD
      !       3) POINTER Ƃ̖ȂD
      !       2) ĂяoŊtĂC[`INTENT(out) Ȃ΂ׂĖ
      !
      !    ւALLOCATABLE(F2003K)t^KvƂȂ̂́C{[`̂悤
      !    炩߃TCYȂztꍇłDȂ킿2pXȏꍇD
      !
      !       1.  pX1Fz𓮓It邽߂ɂ̑傫𒲍
      !       2.         zɃ𓮓It
      !       3.  pX2Ftꂽzɒli[
      !
      !      F90/95K ōsƂƁC2ȂD
      !
      !       A) L 1.  3. pɂꂼ [`pӂiĂяoώGj
      !       B) ALLOCATABLEłȂ POINTER gĎ
      !                                          iDEALLOCATE Ȃƃ[Nj

      INTEGER, ALLOCATABLE :: nc(:) !(minY:maxY) Zs̐^JE^ (Num. of Components)
      INTEGER :: minY, maxY
      INTEGER :: nX                 ! Num. of Y's components per X, total Num of X
      INTEGER :: X, Y

      nX  = SIZE( X2Y )             ! nelm  nedge

      ! 0. It̂߂̗\
      IF ( PRESENT( minY_) ) THEN
         IF ( .NOT. PRESENT( maxY_) ) STOP "minY_ w肵 maxY_ K{"
         minY = minY_
      ELSE
         minY = MINVAL( X2Y )
      END IF

      IF ( PRESENT( maxY_) ) THEN
         IF ( .NOT. PRESENT( maxY_) ) STOP "maxY_ w肵 minY_ K{"
         maxY = maxY_
      ELSE
         maxY = MAXVAL( X2Y )
      END IF

      ! 1. t Y2Xe[u (jagged z) փ𓮓It
      ALLOCATE ( nc(minY:maxY) )
      nc(:) = 0                     ! eY  Y2X(Y)%c(:) ɕKvȃ nc(Y) vZ
      Pass1: DO X = 1, nX
         Y = X2Y(X)
         nc(Y) = nc(Y) + 1
      END DO Pass1

      ALLOCATE ( Y2X(minY:maxY) )   ! It
      DO Y = minY, maxY
         ALLOCATE ( Y2X(Y)%c(1:nc(Y)) )
      END DO

      ! 2. tf[^̊i[
      nc(:) = 0                     ! eY  Y2X(Y)%c(:) ւ̊i[ʒu
      Pass2: DO X = 1, nX
         Y = X2Y(X)
         nc(Y) = nc(Y) + 1
         Y2X(Y)%c(nc(Y)) = X
      END DO Pass2
      DEALLOCATE ( nc )

      DO Y = minY, maxY
         CALL sort( Y2X(Y)%c )      ! ̂߂ c(:) ɕёւĂ
      END DO

   END SUBROUTINE mk_Y2X_from_X2Y_1D


   SUBROUTINE mk_Y2X_from_X2Y_2D ( Y2X, X2Y, minY_, maxY_ )

      ! 2e[u X2Y(1:nYx,1:nX)  te[u Y2X(minY:maxY)%c(:) 쐬
      ! i͋`z񂾂CtjaggedzȂ̂ŒӁj
      !
      ! {[`̎gp
      !  E elm2node ( 1:nnodee, 1:nelm  )  node2elm ( 1:nnode )%c(:)    ( V2N  N2V )
      !  E edge2node( 1:2,      1:nedge )  node2edge( 1:nnode )%c(:)    ( E2N  N2E )
      !  E elm2DOF  ( 1:nDOFe,  1:nelm  )  DOF2elm  ( nDOF_n:nDOF_p )%c(:)
      !
      !      nnodee : Num. of NODEs per Element
      !      nDOFe  : Num. of DOFs  per Element ( not only node but also edge )
      !
      !                              X                                Xy = p(Y)
      !  X2Y(1:nYx, 1:nX) =  [ 1, 1, 1, 3 ]    Y2X(1:nY)%c(:) =    [ 1, 2, 3 ]   nXy = 3
      !                     Yx [ 2, 3, 5, 5 ]                        [ 1 ]               1
      !                                                              Y [ 2, 4 ]            2
      !    nYx: Num. of Y's components per X (SXœ)               [ ]                 0
      !    nXy:   V    X                  Y (eYɈˑ)               [ 3, 4 ]            2

      TYPE(jag), ALLOCATABLE, INTENT(out  ) :: Y2X(:)  !(minY:maxY)  t (ALcF2003K)
      INTEGER,                INTENT(in   ) :: X2Y(:,:)!(1:nYx,1:nX) 
      INTEGER,  OPTIONAL,     INTENT(in   ) :: minY_   ! MINVAL(X2Y) maxY_ ƃZbg
      INTEGER,  OPTIONAL,     INTENT(in   ) :: maxY_   ! MAXVAL(X2Y) minY_    V

      INTEGER, ALLOCATABLE :: nc(:) !(minY:maxY) Zs̐^JE^ (Num. of Components)
      INTEGER :: minY, maxY
      INTEGER :: nYx, nX            ! Num. of Y's components per X, total Num of X
      INTEGER :: X, Yx
      INTEGER :: Y, Xy

      nYx = SIZE( X2Y, DIM=1 )      ! nnodee  2CnDOFe
      nX  = SIZE( X2Y, DIM=2 )      ! nelm  nedge

      IF ( PRESENT( minY_) ) THEN
         IF ( .NOT. PRESENT( maxY_) ) STOP "minY_ w肵 maxY_ K{"
         minY = minY_
      ELSE
         minY = MINVAL( X2Y )
      END IF

      IF ( PRESENT( maxY_) ) THEN
         IF ( .NOT. PRESENT( maxY_) ) STOP "maxY_ w肵 minY_ K{"
         maxY = maxY_
      ELSE
         maxY = MAXVAL( X2Y )
      END IF

      ALLOCATE ( nc(minY:maxY) )
      nc(:) = 0
      Pass1: DO X = 1, nX
         DO Yx = 1, nYx
            Y = X2Y(Yx,X)
            nc(Y) = nc(Y) + 1
         END DO
      END DO Pass1

      ALLOCATE ( Y2X(minY:maxY) )
      DO Y = minY, maxY
         ALLOCATE ( Y2X(Y)%c(1:nc(Y)) )
      END DO

      nc(:) = 0
      Pass2: DO X = 1, nX
         DO Yx = 1, nYx
            Y = X2Y(Yx,X)
            nc(Y) = nc(Y) + 1
            Y2X(Y)%c(nc(Y)) = X
         END DO
      END DO Pass2
      DEALLOCATE ( nc )

      DO Y = minY, maxY
         CALL sort( Y2X(Y)%c )
      END DO

   END SUBROUTINE mk_Y2X_from_X2Y_2D
!
!*********************
   SUBROUTINE mk_A2B_from_A2C_and_preB2C ( A2B, A2C, Ba2Ca, preB2C_, nC_, nB_ )

      ! B ւ̔ԍt  A2B(:,:) ̍쐬CA2C(:,:)  Ba2Ca(:,:) ̏pčsD
      ! ̂ƂCB ̂ 炩 preB2C_(:,:) ɂĎw肳ꂽ̂΁CȊO
      !  B ւ̔ԍtɗD悵 1 炻̔zт̏ŘAԂUD
      ! Ȃ킿CpreB2C_(:,:) ́Cق mk_B2C_from_A2B_and_A2C pꍇɍ쐬
      !  B2C(:,:)̐擪ƁC̏ēłDpreB2C_(:,:)̌𓯈
      ! łȂ̂́CASY̎dlセ̌قǂ B2C(:,:) ɂ͌płȂߎdȂD
      !
      ! ) ӂւ̑S̔ԍt  V2E(:,:)(̗vfS̕Ӕԍւ̕ϊDB)̍쐬CV2N(:,:)
      !     (̗vfS̐ߓ_ԍւ̕ϊDB)  Ev2Nv(:,:)(̗vf̗vfӂvfߓ_ԍ
      !     ւ̕ϊTBL) ̏pčsD̂ƂCS̕ӂ̂\ʃohɊ܂܂
      !     ɂẮC preB2C_(:,:) ɂĎw肵ĂƂɂCS̕Ӕԍ 
      !     w菇 1,2,3.... ƂłDAC͕̏ۑȂ̂ŁC
      !     mk_B2C_from_A2B_and_A2C pč쐬B2C(:,:) ̐擪preB2C_(:,:) 
      !     ߂Đݒ肷KvD
      
      ! ) \ʂɂ閳RYӂɉۂ߂ɂ́CF2E(:,:)(\ʗvfS̕Ӕԍւ
      !     ϊDB)쐬Ăƕ֗łD̍쐬́CF2N(:,:)(\ʗvfS̐ߓ_ԍ
      !     ւ̕ϊDB)CEf2Nf(:,:)(\ʗvf̗vfӂvfߓ_ԍւ̕ϊTBL)CpreE2N(:,:)
      !     (S̕ӂS̐ߓ_ԍւ̕ϊDB) ̏pčsD
      !     i2007.7.16 ǁC̗͕svƂȂDj

      INTEGER,           INTENT(out  ) :: A2B(:,:)     ! (nBa, nA)
      INTEGER,           INTENT(in   ) :: A2C(:,:)     ! (nCa, nA)
      INTEGER,           INTENT(in   ) :: Ba2Ca(:,:)   ! (nCb,nBa)
      INTEGER, OPTIONAL, INTENT(in   ) :: preB2C_(:,:) ! (nCb,npreB)
      INTEGER, OPTIONAL, INTENT(in   ) :: nC_
      INTEGER, OPTIONAL, INTENT(out  ) :: nB_

      TYPE(jag), ALLOCATABLE :: C2A(:)       ! (nC )
      INTEGER,   ALLOCATABLE :: C0(:), C1(:) ! (nCb)
      INTEGER :: nA, npreB,  nC, nBa, nCa, nCb
      INTEGER ::  A,     B,       Ba,       Cb

      nA  = SIZE( A2C,   DIM=2 ); IF ( nA /= SIZE( A2B, DIM=2 ) ) STOP "zTCYႤ"
      nCa = SIZE( A2C,   DIM=1 )
      nBa = SIZE( Ba2Ca, DIM=2 ); IF ( nBa/= SIZE( A2B, DIM=1 ) ) STOP "zTCYႤ"
      nCb = SIZE( Ba2Ca, DIM=1 )

      IF ( PRESENT( nC_ ) ) THEN
         nC = nC_
      ELSE
         nC = MAXVAL( A2C )
      END IF

      ALLOCATE ( C0(nCb), C1(nCb) )

      CALL mk_Y2X_from_X2Y_2D ( Y2X=C2A, X2Y=A2C, minY_=1, maxY_=nC )

      A2B(:,:) = 0

      ! preB2C_ ɂ ɔԍwς(1,2,...Ŕz̏)  B ɂāCA2B 쐬D
      IF ( PRESENT( preB2C_ ) ) THEN
         A = 0                              ! set_A2B L邽߂̃I}WiC
         npreB = SIZE( preB2C_, DIM=2 )
         DO B = 1, npreB
            FORALL ( Cb = 1:nCb ) C0(Cb) = preB2C_(Cb,B)
            CALL set_A2B ( )
         END DO
      ELSE
         npreB = 0
      END IF

      ! preB2C_ ɂĎw肳Ȃ B ɂāCւ̔ԍtCA2B 쐬D
      ! ȂCpreB2C_ ɂđSĂ̂ B ɔԍw肳ĂꍇCȉ̃[v͕sv
      ! ł邪CKsĂ܂̂ŁC኱łD
      ! iNeBJ䂦CXs[hR[h̃RpNgdʁj
      B = npreB
      DO A = 1, nA
         DO Ba = 1, nBa
            IF ( A2B(Ba,A ) /= 0 ) CYCLE    ! Ɋčς݂䂦 Ba 
            B = B + 1                       ! w䂦 B ̑S̔ԍ +1 Ĕԍt
            A2B(Ba,A ) = B
            !  B ɐڑĂ C XgAbv
            FORALL ( Cb = 1:nCb ) C0(Cb) = A2C( Ba2Ca(Cb,Ba), A )
            CALL set_A2B ( )
         END DO
      END DO

      IF ( PRESENT ( nB_ ) ) nB_ = B

      DEALLOCATE ( C0, C1 )
      DEALLOCATE ( C2A )

   CONTAINS

      SUBROUTINE set_A2B ( )
         INTEGER :: A1, A1c, B1a          
         ! XgAbvꂽ C0(:) 𗊂ɁC B L A1(>A) oCs
         A1c_loop: DO A1c = SIZE( C2A(C0(1))%c(:), DIM=1 ), 1, -1  ! t
            A1 = C2A(C0(1))%c(A1c)       ! C0(1)ɐڑĂA1 CC(2:)ɐڑĂ邩
            IF ( A1 <= A ) EXIT A1c_loop ! C2A(C0(1)%c(:) ͏ς݂䂦
            DO Cb = 2, nCb
               IF ( .NOT. ANY(C2A(C0(Cb))%c(:)==A1) ) CYCLE A1c_loop
            END DO                       ! ANY ͒낤CNeBJ䂦Cǐd
            ! ɒH蒅̂́CA1CȂ킿 A1  S C0(:) ɐڑĂꍇ̂
            ! ȉ C0(:) ƐڑĂ Ba
            B1a_loop: DO B1a = 1, nBa
               FORALL ( Cb = 1:nCb ) C1(Cb) = A2C( Ba2Ca(Cb,B1a), A1 )
               DO Cb = 1, nCb
                  IF ( .NOT. ANY(C1(:)==C0(Cb)) ) CYCLE B1a_loop
               END DO
               ! ɒH蒅̂́CB1aCȂ킿 B1a S C(:) ɐڑĂꍇ̂
               A2B(B1a,A1) = B
            END DO B1a_loop
         END DO A1c_loop
      END SUBROUTINE set_A2B

   END SUBROUTINE mk_A2B_from_A2C_and_preB2C
!
!*********************
   SUBROUTINE mk_B2C_from_A2B_A2C_and_preB2C ( B2C, A2B, A2C, Ba2Ca, preB2C_ )

      ! B2C(:,:) ̍쐬CA2B(:,:)CA2C(:,:)CBa2Ca ̏pčsD̂ƂCB ̂ 
      ! 炩 preB2C_(:,:) ɂĎw肳ꂽ̂΁C̕ B2C(:,:) ̐擪
      ! ĕԂD́C mk_A2B_from_A2C_and_preB2C p preB2C_(:,:) 
      ! w肵ꍇɁCASY̎dlセpreB2C_(:,:) ̌̏płȂ
      ! ߁Cނ𓾂ȂdlƂȂĂD
      !
      ! ) E2N(S̕ӂS̐ߓ_ԍւ̕ϊDB) ̍쐬CV2E(:,:)(̗vfS̕Ӕԍւ
      !     ϊDB)CV2N(:,:)(̗vfS̐ߓ_ԍւ̕ϊDB)CEv2Nv(:,:)(̗vf̗vfӂ
      !     vfߓ_ԍւ̕ϊTBL)̏pčsD̂ƂCS̕ӂ̂ \ʃoh
      !     ܂܂ӂɂẮC `ł preB2C_(:,:) ɂĎw肵ĂKv
      !     D

      INTEGER,           INTENT(out  ) :: B2C  (:,:)   ! (nCb, nB)
      INTEGER,           INTENT(in   ) :: A2B  (:,:)   ! (nBa, nA)
      INTEGER,           INTENT(in   ) :: A2C  (:,:)   ! (nCa, nA)
      INTEGER,           INTENT(in   ) :: Ba2Ca(:,:)   ! (nCb,nBa)
      INTEGER, OPTIONAL, INTENT(in   ) :: preB2C_(:,:) ! (nCb,npreB)

      INTEGER ::   A,  Ba,   B,  Ca,  Cb   ,npreB
      INTEGER ::  nA, nBa,  nB, nCa,  nCb

      nA  = SIZE( A2C,   DIM=2 ); IF ( nA /= SIZE( A2B, DIM=2 ) ) STOP "zTCYႤ"
      nCa = SIZE( A2C,   DIM=1 )
      nB  = SIZE( B2C,   DIM=2 )
      nBa = SIZE( Ba2Ca, DIM=2 ); IF ( nBa/= SIZE( A2B, DIM=1 ) ) STOP "zTCYႤ"
      nCb = SIZE( Ba2Ca, DIM=1 ); IF ( nCb/= SIZE( B2C, DIM=1 ) ) STOP "zTCYႤ"

      ! ȉ̃ASY loop_A ł́C邢͖ʂ̌KłȂ߁C
      ! K肵ꍇɂ preB2C_(:,:) ̂܂܏o͂ƂD
      ! ȊO̕ ASYCŐ邢͖ʂ̌܂D
      IF ( PRESENT( preB2C_ ) ) THEN
         npreB = MIN(nB, SIZE( preB2C_, DIM=2 ) )  ! npreB > nB ȂĂƂ͂Ȃ͂c
         B2C(:,1:npreB) = preB2C_(:,1:npreB)
         IF ( npreB == nB ) RETURN
      ELSE
         npreB = 0
      END IF
      B2C(:,npreB+1: ) = 0

      loop_A: DO A = 1, nA
         DO Ba = 1, nBa
            B = A2B(Ba,A )
            IF ( B2C(1,B) /= 0 ) CYCLE ! B2C(:,B)͈CɃZbg邽ߍŏ1Ŕfł
            FORALL( Cb = 1:nCb) B2C(Cb,B) = A2C( Ba2Ca(Cb,Ba), A )
         END DO
      END DO loop_A

   END SUBROUTINE mk_B2C_from_A2B_A2C_and_preB2C
!
!*********************
   SUBROUTINE mk_tree_of_B_in_C ( B_is_Tree, B2C, buffer_sub, preA2C_, nC_, st_C_ )

      ! C𒸓_CB}ƂāCB2C(:,:) ɂĒ`Ot̖ B_is_Tree ԂD
      ! B_is_Tree(:)  0 ȂΕ؁C[ȂΖ؂łDɁC̐Βl͖؂̏
      ! DȂCpredefine Ȗ؏WƁCPAWɓ̏𕄍}CiX
      ! ɕςĐUDOvO buffer_sub (buffer_classI) ɂC
      ! X^bNpush ΐ[DT(Depth First Search)CL[enterΕDT
      ! (Breadth First Search)DpreA2C_ ݂ꍇɂ́CA ̕ӂ predefine ĂB 
      ! ̖؂Ɖ߂DȂCpreA2C_  preB2C łǂD

      ! QljΔ, ASYƃf[^\, 4́FOt̃ASYCgX

      INTEGER,           INTENT(out  ) :: B_is_Tree(:) ! ( nB ) ؂ȂΔ[C؂Ȃ΃[
      INTEGER,           INTENT(in   ) :: B2C    (:,:) ! (nCb, nB)
      EXTERNAL                         :: buffer_sub   ! buffer_class  subroutine ̂ЂƂ
      INTEGER, OPTIONAL, INTENT(in   ) :: preA2C_(:,:) ! (nCa, nA) \ߖ؂Ƃ鑽AOt
      INTEGER, OPTIONAL, INTENT(in   ) :: nC_          ! Number of C
      INTEGER, OPTIONAL, INTENT(in   ) :: st_C_        ! T̋N_ƂȂ钸_

      INTEGER, ALLOCATABLE   :: v_C(:)        ! (nC) C̏iK̏ԁjƖKtOp
      INTEGER, ALLOCATABLE   :: v_A(:)        ! (nA) ȀiK̏ԁjƖKtOp
      INTEGER, PARAMETER     :: unvisited = 0 ! KtO
      INTEGER, PARAMETER     :: visited   = 1 ! KσtO
      INTEGER                :: treeNo        ! ؂̏iK̏ԁj
      TYPE(jag), ALLOCATABLE :: C2B (:)       ! B2C    (:,:) ̋t
      TYPE(jag), ALLOCATABLE :: C2A (:)       ! preA2C_(:,:)    V
      TYPE(buf_c)            :: buf
      TYPE(buf_c)            :: bufA

      INTEGER ::  nB, nC,                 nCb
      INTEGER ::   B,     iC, jC, kC, Bc,  Cb
      INTEGER ::  nA,                nAc, nCa
      INTEGER ::          iA, jA,     Ac,  Ca
      LOGICAL :: is_visited_all

      nB  = SIZE( B2C, DIM=2 ); IF ( nB /= SIZE( B_is_Tree, DIM=1 ) ) STOP "zTCYႤ"
      nCb = SIZE( B2C, DIM=1 )

      IF ( PRESENT( nC_ ) ) THEN
         nC = nC_
      ELSE
         nC = MAXVAL( B2C )
      END IF
      ALLOCATE ( v_C (nC) )
      v_C(:) = unvisited

      CALL mk_Y2X_from_X2Y_2D( Y2X=C2B, X2Y=B2C, minY_=1, maxY_=nC ) ! B2C ̋tϊ C2B 쐬
      CALL init ( buf, nC )             ! obt@TCY̍ő nC ŗ}

      IF ( PRESENT( preA2C_ ) ) THEN
         nA  = SIZE( preA2C_, DIM=2 )
         nCa = SIZE( preA2C_, DIM=1 )
         ALLOCATE ( v_A(nA) )
         v_A(:) = unvisited
         CALL mk_Y2X_from_X2Y_2D( Y2X=C2A, X2Y=preA2C_, minY_=1, maxY_=nC )
         CALL init ( bufA,  nA  )       ! obt@TCY̍ő nA ŗ}
      END IF

      treeNo = 0
      B_is_Tree(:) = 0
      IF ( PRESENT( st_C_ ) ) THEN
         jC = st_C_
      ELSE
         jC = 1
      END IF
      v_C(jC) = visited
      CALL buffer_sub ( buf, jC )       ! push jC in stack / enter jC in queue
      IF ( PRESENT( preA2C_ ) ) CALL find_PreTree_originated_from_jC ( )
      DO

         IF ( is_empty( buf ) ) THEN    ! 2009.2.9 AɑΉij܂ł͒PAc
            is_visited_all = .TRUE.     !iZȀꍇ͒PEXIT j
            DO kC = 1, nC               ! ǂȂEEE܂䖝D
               IF ( v_C(kC) == unvisited ) THEN
                  is_visited_all = .FALSE.
                  jC = kC               ! ȀꍇC̎n_͍ŏ̂
                  v_C(jC) = visited
                  CALL buffer_sub ( buf, jC )       ! push jC in stack / enter jC in queue
                  IF ( PRESENT( preA2C_ ) ) CALL find_PreTree_originated_from_jC ( )
                  EXIT
               END IF
            END DO
            IF ( is_visited_all ) EXIT
         END IF

         CALL retrieve( buf, iC )       ! ҂s񂩂 iC oD
         DO Bc = 1, SIZE( C2B(iC)%c(:), DIM=1 )
            B  = C2B(iC)%c(Bc)
            DO Cb = 1, nCb
               jC = B2C(Cb, B)
               IF ( v_C(jC) == unvisited ) THEN
                  v_C(jC) = visited
                  treeNo = treeNo +1
                  B_is_Tree(B) = treeNo       ! ؂ł邱Ƃ͐ŕ\ł邪Ct
                  CALL buffer_sub ( buf, jC ) ! push jC in stack / enter jC in queue
                  IF ( PRESENT( preA2C_ ) ) CALL find_PreTree_originated_from_jC ( )
               END IF
            END DO
         END DO
      END DO

      IF ( PRESENT( preA2C_ ) ) THEN
         CALL final ( bufA )
         DEALLOCATE ( v_A, C2A )
      END IF

      CALL final ( buf )
      DEALLOCATE ( v_C, C2B )

   CONTAINS

      SUBROUTINE find_PreTree_originated_from_jC ( )

         ! _ jC N_ƂāCpreA2C_ ̕ӂ predefine ꂽ؂邩ǂ
         ! ̊mFsC݂Ă΁CjC𒸓_Ɋ܂ޒPAȕӏWCɒT
         ! ̖؂Ƃ݂ȂēiKԍjC}CiXɑւĐUD

         ! s߂ɁCA  A2C, C2A ̏ŏK₵ĂD
         ! ȂCCK₵Ă菇 C2A, A2C ƂȂCt֌WɂȂD

         LOGICAL :: exist_PreTree
         INTEGER :: kBc, kB, kCb

         ! jC  predefine Ȗ؂̒_ł邩ǂ̃`FbN
         exist_PreTree = .FALSE.                    
         DO Ac = 1, SIZE(C2A(jC)%c(:),DIM=1)
            jA = C2A(jC)%c(Ac)
            IF ( v_A(jA) /= visited ) THEN
               exist_PreTree = .TRUE.               ! predefine Ȗ؂!
               v_A(jA) = visited
               CALL buffer_sub(bufA, jA )
            END IF
         END DO
         IF ( exist_PreTree ) THEN
            treeNo = treeNo +1
         ELSE
            RETURN
         END IF

         DO
            IF ( is_empty( bufA ) ) EXIT

            CALL retrieve( bufA, iA )    ! A ̃obt@1oD
            DO Ca = 1, nCa
               kC = preA2C_(Ca, iA )     ! iA  C = kC ɒځDN_ jA  kB T

               DO kBc = 1, SIZE(C2B(kC)%c(:),DIM=1) ! iA B T
                  kB = C2B(kC)%c(kBc)               ! iA B Dȉŏ𖞂eXg
                  DO kCb = 1, nCb
                     IF ( B2C(kCb,kB) == kC ) CYCLE ! g
                     IF ( ANY( B2C(kCb,kB) == preA2C_(:,iA) ) ) THEN  ! kB  iA ɂꍇ
                        B_is_Tree(kB) = -TreeNo     ! ̕ӂɑ΂Đ邪C
                     END IF                         ! NeBJ䂦OK (dlŃ}CiX)
                  END DO
               END DO

               IF (v_C(kC) /= visited ) THEN        ! predefineȖ؂K₵Ƃ̃tO
                  v_C(kC) = visited                 ! C ̃obt@Ɋi[
                  CALL buffer_sub(buf, kC)
               END IF

               DO Ac = 1, SIZE(C2A(kC)%c(:),DIM=1)  ! Aɂ邻̑K A T
                  jA = C2A(kC)%c(Ac)                ! A = jA ƂÃobt@Ɋi[
                  IF ( v_A(jA) /= visited ) THEN
                     v_A(jA) = visited
                     CALL buffer_sub(bufA, jA )
                  END IF
               END DO

            END DO
         END DO

      END SUBROUTINE find_PreTree_originated_from_jC

   END SUBROUTINE mk_tree_of_B_in_C

END MODULE mesh_module
