module timer

   INTEGER, PARAMETER :: I8 = SELECTED_INT_KIND(2*RANGE(0))    ! 
   INTEGER(I8), SAVE  :: cnt_st = 0 

contains

   SUBROUTINE tic ( )
      ! oߎ(wall time)v^C}[Zbg
      CALL SYSTEM_CLOCK ( cnt_st )
   END SUBROUTINE tic


   FUNCTION toc ( ) RESULT ( wall_time )
      ! oߎ(b)ԂiCPUԂƂ͈Ⴄ̂ŒӁj
      REAL        :: wall_time
      INTEGER(I8) :: cnt_now, cnt_rate, cnt_max  ! ^Ȃ̂́C0.01bȉ̍xv̂
      REAL        :: diff
      IF ( cnt_st == 0_I8 ) THEN
         WRITE(*,*) "ӁjoߎԌv^C}[Zbg䂦C}CiXoߎԂ߂܂"
         CALL tic ( )
         wall_time = -9.999
         RETURN
      END IF
      CALL SYSTEM_CLOCK ( cnt_now, cnt_rate, cnt_max )
      IF ( cnt_st <= cnt_now ) THEN
         diff = cnt_now - cnt_st
      ELSE
         diff = cnt_max - cnt_st + cnt_now
      END IF
      wall_time = diff / cnt_rate
   END FUNCTION toc
end module timer


program test

use sort_and_search_module
use timer

integer :: a(8)  = (/4,2,1,3,9,2,  0,0 /)
integer :: id(6) = (/1,2,3,4,5,6/)

real, allocatable :: r(:)
integer, allocatable :: b1(:), b2(:), b3(:)
logical :: exist1, exist2
integer :: L1, L2

call sort ( a(1:6) )

write(*,*) a
write(*,*) id

!print *, 'input size'
!read *, n

!allocate( r(n), b1(n), b2(n), b3(n))

!call random_number( r )
!b1 = INT(10000*r)
!b2 = b1
!b3 = b1

!call tic
!call selection_sort_int( b1 )
!print "(A,F10.5)", 'selection sort', toc()

!call tic
!call insertion_sort_int( b2 )
!print "(A,F10.5)", 'insertion sort', toc()

!call tic
!call shells_sort_int   ( b3 )
!print "(A,F10.5)", 'shell''s sort', toc()

! print *, ' 0 Ȃ΃\[eBOĂ', maxval(abs(b1-b3)) 

!call sort ( b3 )

!print *, "sort: done"


id = (/2, 4, 6, 8, 10, 12 /)

print *, id

do i = 1, 14, 1
  L1 = binary_search_method_1_int ( i, id(1:5), exist1 )
  L2 = binary_search_method_2_int ( i, id(1:5), exist2 )
print *, L1, exist1, '|', L2, exist2,   L1-L2, exist1 == exist2
end do


end
