% JSCESp̐}`matlabXNvg

name = 'rectangular';

elm2node = load([name,'.elm.dat']);
elm2node = elm2node(:,1:end-1);   % ޗ̈ԍO
node2X   = load([name,'.node.dat']);

[nelm, nnodee] = size(elm2node);
[nnode, ndim ] = size(node2X);

elm2col = load('elm_color.dat');
elm_adj = load('elm_adj.dat');

ncol = max(elm2col(:));
colormap(hsv(ncol))
% bV̕`

clf
set(gcf,'Color','white');

H_mesh_gray = patch('faces',elm2node,'vertices',node2X,...
               'FaceColor',[0.7,0.7,0.7],...
               'Marker','o',...
               'LineWidth',0.75,...
               'MarkerSize',5,...
               'MarkerFaceColor','black',...
               'MarkerEdgeColor','none');
axis off
axis equal
pause

clf
%%%eF݂̂`悷ꍇɂ͈ȉRgAEg
%for i = 1: max(elm2col)
%ELM2COL = elm2col;
%for k = 1:length(elm2col)
%   if elm2col(k)~=i
%      ELM2COL(k)=NaN;
%   end
%end
%subplot(2,3,i)
H_mesh = patch('faces',elm2node,'vertices',node2X,...
               'FaceColor','flat',...
               'CData',elm2col,  'CDataMapping','direct',...
               'Marker','o',...
               'LineWidth',0.75,...
               'MarkerSize',5,...
               'MarkerFaceColor','black',...
               'MarkerEdgeColor','none');
axis off
axis equal
%end
pause

clf

% vf̍WlZo
elm2X = zeros(nelm,ndim);
for j = 1: nnodee
   elm2X = elm2X + node2X(elm2node(:,j),:);
end
elm2X = elm2X./nnodee;

% S̎RxvfԂ̐ڑ󋵂`
siz = (size(elm_adj,1) - nelm )/2;   % vfԂԐ̐igւ0̐ƁC2̐1ɂj
elm_adj_upper = zeros(siz,2);
ee = 0;
for e = 1:size(elm_adj,1)
   if elm_adj(e,1) < elm_adj(e,2)
      ee = ee +1;
      elm_adj_upper(ee,:) = elm_adj(e,:);
   end
end

H_mesh_gray = patch('faces',elm2node,'vertices',node2X,...
               'FaceColor',[0.7,0.7,0.7],...
               'LineWidth',0.75,...
               'Marker','o',...
               'MarkerSize',5,...
               'MarkerFaceColor','black',...
               'MarkerEdgeColor','none');

H_elm_network = patch('faces',elm_adj_upper,'vertices',elm2X,...
               'CData',elm2col,  'CDataMapping','direct',...
               'EdgeColor','white',...
               'LineWidth',2,...
               'Marker','o',...
               'MarkerSize',10,...
               'MarkerFaceColor','flat',...
               'MarkerEdgeColor','none'...
               );

axis off
axis equal
