! e(ISOtropic elastic body)̐`\NX
!
!     {} } = [cE]  {}       ЁF́CÁFc
!                               { } ̓e\̃xNg\C[ ] ̓e\̍s\
!     ɁC
!     E2-D Ȃ     { 11 }            {   11 }
!               {} = { 22 } ,   {} = {   22 }  Hwc݂ł邱ƂɒӁI
!                      { 12 }            { 2*12 }
!
!     E3-D Ȃ     { 11 }            {   11 }
!                      { 22 }            {   22 }
!               {} = { 33 } ,   {} = {   33 }  Hwc݂ł邱ƂɒӁI
!                      { 12 }            { 2*12 }
!                      { 23 }            { 2*23 }
!                      { 31 }            { 2*31 }
!
! ) 2KΏ̃e\̐xNg\́Ce͊wƌő̕ł͈قȂĂ̂Œӂ邱ƁD
!     e͊wF            111, 222, 333, 124, 235, 316i̗pj
!     ő̕FVoigtL@F   V     V     V   234, 315, 126

MODULE material_class

   USE constants

   IMPLICIT none                          ! Öق̌^錾֎~
   PRIVATE                                ! O(PUBLIC)āC{W[O͉B

#ifdef TWO
   INTEGER, PARAMETER, PUBLIC :: ndim = 2
#else
   INTEGER, PARAMETER, PUBLIC :: ndim = 3
#endif

   INTEGER, PARAMETER, PUBLIC :: nrot = ndim*(ndim-1)/2 ! ]Rx (Num of rotation DOFs)
   INTEGER, PARAMETER, PUBLIC :: nstr = (ndim+1)*ndim/2 ! /cݐ (Num of stresses/strains)

   ! ޗ̈敨Ɋւ Abstract Data Type, ADT ̒`i͂cݓ͍ޗ̈**ł͂Ȃj
   TYPE, PUBLIC :: mat_c
      PRIVATE                             ! {W[O͉BD
      REAL(DP) :: D (nstr, nstr )         ! eWs
      REAL(DP) :: Db(nstr, nstr )         ! Ȃp̋Ȃs
      REAL(DP) :: Ghk                     !     V    fW
      REAL(DP) :: rho                     ! x
   END TYPE mat_c

   ! control_module Ă΂D
   PUBLIC :: init
   INTERFACE init
      ! w̃t@Cuԍ̈敨lǂݍ݁Cmat_c ̎̂ɃZbg.
      MODULE PROCEDURE read_iso_mat_c
   END INTERFACE

   ! ȉ̃[`Q́Celement_class ̂݌Ă΂D
   PUBLIC :: eval_Mass
   INTERFACE eval_Mass
      ! xԂ
      MODULE PROCEDURE eval_Mass_dens_mat
   END INTERFACE

   PUBLIC :: eval_Fin_and_K
   INTERFACE eval_Fin_and_K
      ! \ y=f(x) ̒l y|x=x,yfԂD
      MODULE PROCEDURE eval_Fin_and_K_iso_mat, &
                     & eval_Fin_and_K_iso_bend
   END INTERFACE

CONTAINS

!***************************************************************************************************
   SUBROUTINE  read_iso_mat_c ( this, uid, status )

      ! t@Cuԍuid ễOC|A\Cxǂݍ mat_cɃZbg

      TYPE(mat_c),       INTENT(out  ) :: this
      INTEGER,           INTENT(in   ) :: uid           ! t@C̑uԍ
      INTEGER, OPTIONAL, INTENT(out  ) :: status        ! I/O ANZX̌

      REAL(DP), PARAMETER :: kappa = 5.0_DP / 6.0_DP    ! Reissner ɂ邹f̕␳W

      INTEGER  :: i,  stat
      REAL(DP) :: t             ! 2-D  t > 0 ̂ƂCʉ͖ɂDȊO̓S~
      REAL(DP) :: E,    nu      ! O EC|A\
      REAL(DP) :: lmbd, mu      ! [萔(ɁC)
      REAL(DP) :: c

      ! ޗ̈敨l̓ǂݍ
      this%rho = 0.0_DP                        ! u/vɂ鋭Ő؂ɔ
      t        = 0.0_DP                        !           V
      READ ( uid, *, IOSTAT = stat ) E, nu, this%rho, t
      IF ( PRESENT(status) ) status = stat

      ! FCxĂ΂Ȃ̂ŁCvZ͖ėǂCPAX~Xh~ǂ݈ՂD
      lmbd = E * nu /(( 1.0_DP + nu ) * ( 1.0_DP - 2.0_DP*nu ) ) !   (lambda)
      mu   = E      / ( 1.0_DP + nu ) *   0.5_DP                 !   (mu)

      IF ( ndim == 2 .AND. t > 0.0_DP ) THEN   ! ʉ͖̂ƂC
         ! 2-D  3-D }N߂ɂĐ؂蕪̂ǂ́CYݒEEEE
         c      = E / (1.0_DP - nu**2 )
         this%D(1,1:3) = (/      c,   nu*c, 0.0_DP /)
         this%D(2,1:3) = (/   nu*c,      c, 0.0_DP /)
         this%D(3,1:3) = (/ 0.0_DP, 0.0_DP, mu     /)
         this%D(:,:)   = this%D(:,:) * t       ! t |Ă邱ƂYȂ悤ɁI
         ! ȉ́CȂ
         this%Db(:,:)  = this%D(:,:) *(t*t/12.0_DP)
         this%Ghk      = mu * t * kappa
      ELSE                                     ! ʂЂݖ 3̂Ƃ
         this%D(:,:) = 0.0_DP
         this%D(1:ndim,1:ndim) = lmbd
         FORALL ( i =      1:ndim ) this%D(i,i) = this%D(i,i) + mu*2.0_DP
         FORALL ( i = ndim+1:nstr ) this%D(i,i) = mu
      END IF

   END SUBROUTINE read_iso_mat_c

!***************************************************************************************************
   PURE SUBROUTINE eval_Mass_dens_mat ( this, rho )
      TYPE(mat_c), INTENT(in   ) :: this
      REAL(DP),    INTENT(out  ) :: rho
      rho = this%rho
   END SUBROUTINE eval_Mass_dens_mat

!***************************************************************************************************
   PURE SUBROUTINE eval_Fin_and_K_iso_mat ( this, strain, stress,  D  )

      ! \ y=f(x) ̒l y|x=x,yfԂD

      TYPE(mat_c),        INTENT(in   ) :: this
      REAL(DP),           INTENT(in   ) :: strain (nstr)  ! c
      REAL(DP),           INTENT(out  ) :: stress (nstr)  ! ́iʉ͖̂Ƃ͍́F*tj
      REAL(DP), OPTIONAL, INTENT(out  ) :: D (nstr,nstr)  ! ee\̍s\

      stress(:) = MATMUL( this%D, strain )   ! ê䂦̓[Dė]vȌvZĂ
                                             ! ACǋƁCǏHڂɂȂ
      IF ( PRESENT(D) ) D(:,:) = this%D(:,:)

   END SUBROUTINE eval_Fin_and_K_iso_mat

!***************************************************************************************************
   PURE SUBROUTINE eval_Fin_and_K_iso_bend ( this, curva, gamma, M,  Q,  Db, Ghk )

      ! Ȃp̍\ y=f(x) ̒l y|x=x yfԂD

      TYPE(mat_c),        INTENT(in   ) :: this
      REAL(DP),           INTENT(in   ) :: curva  (nstr)  ! ȗ
      REAL(DP),           INTENT(in   ) :: gamma  (ndim)  ! fЂ
      REAL(DP),           INTENT(out  ) :: M      (nstr)  ! Ȃ[g
      REAL(DP),           INTENT(out  ) :: Q      (ndim)  ! f
      REAL(DP), OPTIONAL, INTENT(out  ) :: Db(nstr,nstr)  ! Ȃe\̍s\
      REAL(DP), OPTIONAL, INTENT(out  ) :: Ghk            ! f

      M(:) = MATMUL ( this%Db,   curva   )
      Q(:) =          this%Ghk * gamma(:)

      IF ( PRESENT(Db ) ) Db(:,:) = this%Db (:,:)
      IF ( PRESENT(Ghk) ) Ghk     = this%Ghk

   END SUBROUTINE eval_Fin_and_K_iso_bend

END MODULE material_class
